using System;

namespace ConsoleApp1
{
    class Program
    {
        static void pisi(ulong[]a ,ulong l, ulong r)
        {
            for(ulong i=l;i<=r;i++)
                Console.Write(a[i] + " ");
            Console.WriteLine();
        }
        static bool moze(ulong [] a,ulong l,ulong r)
        {
            bool bilo = false;
            for(ulong i=l;i<=r-1;i++)
            {
                if (a[i] > a[i + 1] && bilo)
                    return false;
                else if (a[i] > a[i+1])
                    bilo = true;
            }
            return true;
        }
        static bool mozeM(ulong[]a,ulong l,ulong r)
        {
            bool bilo = false;
            ulong l1 = l;
            ulong r1 = r;
            for(ulong i=l1;i<r1/2;i++)
            {
                if (a[l] > a[r] && bilo)
                    return false;
                else if (a[l] > a[r])
                {
                    bilo = true;
                    r--;
                }
                else
                {
                    l++;
                    r--;
                }
            }
            return true;
        }
        static void Main(string[] args)
        {
            uint n = uint.Parse(Console.ReadLine());
            ulong[] a= new ulong[n];
            string[] red = Console.ReadLine().Split(' ');
            for(uint i=0;i<n;i++)
            {
                a[i] = ulong.Parse(red[i]);
            }
            int k = int.Parse(Console.ReadLine());
            bool[] izlaz = new bool[k];
            for(int i=0;i<k;i++)
            {
                red = Console.ReadLine().Split(' ');
                ulong l = ulong.Parse(red[0]) - 1;
                ulong r = ulong.Parse(red[1]) - 1;
                //pisi(a, l, r);
                izlaz[i] = mozeM(a, l, r);
            }
            foreach (bool x in izlaz)
                if (x)
                    Console.WriteLine("DA");
                else
                    Console.WriteLine("NE");
            Console.ReadLine();
        }
    }
}